﻿Public Class TDB_InvertedView

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'C1NWINDDataSet.Employees' table. You can move, or remove it, as needed.
        Me.EmployeesTableAdapter.Fill(Me.C1NWINDDataSet.Employees)

        C1TrueDBGrid1.DataSource = C1NWINDDataSet.Employees.DefaultView
        ' we'll do the filtering ourselves
        Me.C1TrueDBGrid1.AllowFilter = False
        Dim x As Integer = 10, y As Integer = 20
        Dim tb As TextBox
        Dim l As Label
        For i As Integer = 0 To C1TrueDBGrid1.Splits(0).DisplayColumns.Count - 1
            l = New Label()
            tb = New TextBox()
            AddHandler tb.TextChanged, AddressOf tb_TextChanged
            l.Text = C1TrueDBGrid1.Splits(0).DisplayColumns(i).Name
            l.Location = New Point(x, y)
            tb.Location = New Point(l.Size.Width + 10, y)
            splitter1.Controls.AddRange(New Control() {l, tb})
            y += 25
        Next
    End Sub

    Private Sub tb_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim filter_text As String = DirectCast(sender, TextBox).Text
        Dim index As Integer
        ' build our filter expression
        Dim sb As New System.Text.StringBuilder()
        For Each c As Control In splitter1.Controls
            If DirectCast(sender, TextBox).Equals(c) Then
                index = splitter1.Controls.IndexOf(c)
                For Each dc As C1.Win.C1TrueDBGrid.C1DataColumn In Me.C1TrueDBGrid1.Columns
                    If filter_text.Length > 0 AndAlso dc.DataField = splitter1.Controls(index - 1).Text Then
                        If sb.Length > 0 Then
                            sb.Append(" AND ")
                        End If
                        If dc.DataType = Type.[GetType]("System.Int32") Then
                            sb.Append(dc.DataField + " = " & filter_text)
                        Else
                            sb.Append(dc.DataField + " like " & "'" & filter_text & "*'")
                        End If
                    End If
                Next
            End If
        Next

        ' filter the data
        C1NWINDDataSet.Employees.DefaultView.RowFilter = sb.ToString()
    End Sub

End Class
